@echo off
rem ---
rem Written by worstje on 2017-05-02.
rem Shared with the community of DonationCoder.com because I <3 them. :-)
rem ---

rem Usage: Squash-Directory DIRECTORY
rem
rem where DIRECTORY contains unnecessary layers of subdirectories.

rem Of course, you can just Drag & Drop if you want to.

setlocal

cd %1

:rabbithole

for /f "delims=" %%A in ('dir /b /a-d 2^>nul ^| find /c /v ""') do set "COUNTF=%%A"
for /f "delims=" %%A in ('dir /b /ad 2^>nul ^| find /c /v ""') do set "COUNTD=%%A"

rem echo Files: %COUNTF%
rem echo Directories: %COUNTD%

if "%COUNTF%"=="0" (
	if "%COUNTD%"=="1" (
		for /d %%d in (*) do (
			echo Squashing %%d...
			call :squash "%%d"
			goto rabbithole
		)
	)
)

goto done

:squash
rem ---
rem We need to find a name to rename %1 to in case this directory contains a file/name with the same name.
rem ---

pushd %1

:retry
rem echo Determining temporary name ...
set "TEMPORARYNAME=~temporary-%RANDOM%-%RANDOM%-%RANDOM%-%RANDOM%-%RANDOM%"

if exist "%TEMPORARYNAME%" (
	echo Temporary %TEMPORARYNAME% already exists, retrying name generation...
	goto retry
) else (
	rem echo Does not exist: %TEMPORARYNAME%... carry on.
)

popd

ren %1 "%TEMPORARYNAME%"

if not exist "%TEMPORARYNAME%" (
	echo Error: could not rename "%1" into "%TEMPORARYNAME%" ???
	goto done
)

rem ---
rem Now we know for sure that nothing in the subdirectory conflicts with what we are looking at.
rem ---

pushd "%TEMPORARYNAME%"

for %%f in (*) do (
	move "%%f" .. > nul
)

for /d %%d in (*) do (
	move "%%d" .. > nul
)

popd

rem ---
rem Now we attempt the deletion of the temporary directory ...
rem ---

rmdir "%TEMPORARYNAME%"

if exist "%TEMPORARYNAME%" (
	echo Error: could not remove "%TEMPORARYNAME%" ???
	goto done
)

:done

endlocal